## mingw-w64-glslviewer-1.6.1-2.src.tar.zst

=== Makefile ===
EXE = ./bin/glslViewer

CXX = g++
SOURCES := 	$(wildcard include/*/*.cc) $(wildcard src/*.cpp) $(wildcard src/*/*.cpp) \
			$(wildcard include/oscpack/osc/*.cpp) $(wildcard include/oscpack/ip/posix/*.cpp)
HEADERS := 	$(wildcard include/*/*.h) $(wildcard src/*.h) $(wildcard src/*.h) $(wildcard src/*/*.h) \
			$(wildcard include/oscpack/osc/*.h)   $(wildcard include/oscpack/ip/posix/*.h)
OBJECTS := $(SOURCES:.cpp=.o)

PLATFORM = $(shell uname)
DRIVER ?= not_defined

ifneq ("$(wildcard /opt/vc/include/bcm_host.h)","")
	ifeq ($(shell cat /proc/cpuinfo | grep 'Revision' | awk '{print $$3}' ), c03111)
		PLATFORM = RPI4
		ifeq ($(DRIVER),not_defined)
			DRIVER = gbm
		endif
	else
		PLATFORM = RPI
		ifeq ($(DRIVER),not_defined)
			DRIVER = vc
		endif
	endif
else
	PLATFORM = $(shell uname)
	ifeq ($(DRIVER),not_defined)
		DRIVER = glfw
	endif
endif

$(info ${PLATFORM} platform with $(DRIVER) drivers)

INCLUDES +=	-Isrc/ -Iinclude/
CFLAGS += -Wall -O3 -std=c++11 -fpermissive

ifeq ($(DRIVER),vc)
	CFLAGS += -DGLM_FORCE_CXX14 -DPLATFORM_RPI -DDRIVER_VC -Wno-psabi
	INCLUDES += -I/opt/vc/include/ \
				-I/opt/vc/include/interface/vcos/pthreads \
				-I/opt/vc/include/interface/vmcs_host/linux
	LDFLAGS +=  -L/opt/vc/lib/ \
				-lbcm_host \
				-lpthread

	ifeq ($(shell . /etc/os-release && echo $$PRETTY_NAME),Raspbian GNU/Linux 8 (jessie))
	-	LDFLAGS += -lGLESv2 -lEGL
	else
		LDFLAGS += -lbrcmGLESv2 -lbrcmEGL
	endif

else ifeq ($(DRIVER),gbm)
	CFLAGS += -DPLATFORM_RPI4 -DDRIVER_GBM -Wno-psabi
	INCLUDES += -I/usr/include/libdrm \
				-I/usr/include/GLES2
	LDFLAGS +=  -lGLESv2 -lEGL \
				-ldrm -lgbm \
				-lpthread

else ifeq ($(PLATFORM),RPI)
CFLAGS += -DPLATFORM_RPI -DDRIVER_GLFW -Wno-psabi $(shell pkg-config --cflags glfw3 glu gl)
LDFLAGS += $(shell pkg-config --libs glfw3 glu gl x11 xrandr xi xxf86vm xcursor xinerama xrender xext xdamage) -lpthread -ldl

else ifeq ($(PLATFORM),RPI4)
CFLAGS += -DPLATFORM_RPI4 -DDRIVER_GLFW -Wno-psabi $(shell pkg-config --cflags glfw3 glu gl)
LDFLAGS += $(shell pkg-config --libs glfw3 glu gl x11 xrandr xi xxf86vm xcursor xinerama xrender xext xdamage) -lpthread -ldl

else ifeq ($(PLATFORM),Linux)
CFLAGS += -DPLATFORM_LINUX -DDRIVER_GLFW $(shell pkg-config --cflags glfw3 glu gl)
LDFLAGS += $(shell pkg-config --libs glfw3 glu gl x11 xrandr xi xxf86vm xcursor xinerama xrender xext xdamage) -lpthread -ldl

else ifeq ($(PLATFORM),Darwin)
CXX = /usr/bin/clang++
ARCH = -arch x86_64
CFLAGS += $(ARCH) -DPLATFORM_OSX -DDRIVER_GLFW -stdlib=libc++ $(shell pkg-config --cflags glfw3)
INCLUDES += -I/System/Library/Frameworks/GLUI.framework
LDFLAGS += $(ARCH) -framework OpenGL -framework Cocoa -framework CoreVideo -framework IOKit $(shell pkg-config --libs glfw3)

endif

all: $(EXE)

%.o: %.cpp
	@echo $@
	$(CXX) $(CFLAGS) $(INCLUDES) -g -c $< -o $@ -Wno-deprecated-declarations

$(EXE): $(OBJECTS) $(HEADERS)
	$(CXX) $(CFLAGS) $(OBJECTS) $(LDFLAGS) -rdynamic -o $@

clean:
	@rm -rvf $(EXE) src/*.o src/*/*.o include/*/*.o include/*/*/*.o include/*/*/*/*.o *.dSYM 
	
install:
	@cp $(EXE) /usr/local/bin
	@cp bin/glslLoader /usr/local/bin

install_python:
	@sudo python setup.py install
	@sudo python3 setup.py install

clean_python:
	@rm -rvf build
	@rm -rvf dist]
	@rm -rvf python/glslviewer.egg-info

uninstall:
	@rm /usr/local/$(EXE)
	@rm /usr/local/bin/glslLoader

=== examples/2D/00_tests/Makefile ===
test:
	glslViewer test.frag

test_in_png:
	glslViewer test.frag in.png

test_in_tga:
	glslViewer test.frag in.tga

test_in_gif:
	glslViewer test.frag in.gif

test_in_psd:
	glslViewer test.frag in.psd

test_out_png:
	glslViewer test.frag in.png -E screenshot,out.png

test_out_tga:
	glslViewer test.frag in.png -E screenshot,out.tga

test_out_jpg:
	glslViewer test.frag in.png -E screenshot,out.jpg

test_out_hdr:
	glslViewer test.frag in.png -E screenshot,out.hdr

=== examples/2D/03_buffers/Makefile ===
ripples:
	glslViewer 00_ripples.frag -l

grayscott:
	glslViewer 01_grayscott.frag -l

conway:
	glslViewer 02_conway.frag -l

cfd:
	glslViewer 03_cfd.frag ../00_tests/in.png -l

=== examples/2D/04_script/Makefile ===
temp:
	./temp.sh | glslViewer temp.frag -l

=== examples/2D/05_orca/Makefile ===
all:
	glslViewer orca.frag -p 49162 -l

=== examples/2D/06_chataigne/Makefile ===
all:
	glslViewer chataigne.frag -p 9000 -l

=== examples/2D/07_touchOSC/Makefile ===
all:
	glslViewer touchOSC.frag -p 8000 -l

=== examples/2D/08_score/Makefile ===
all:
	glslViewer score.frag -p 9996 -l

=== examples/3D/01_lighting/Makefile ===
gooch:
	glslViewer 00_gooch.frag head.ply 

shadows:
	glslViewer 01_shadows.frag head.ply 

cubemap:
	glslViewer 02_cubemap.frag head.ply -C uffizi_cross.hdr

spherical_harmmonics:
	glslViewer 03_spherical_harmonics.frag head.ply -C uffizi_cross.hdr

fresnel:
	glslViewer 04_fresnel.vert 04_fresnel.frag head.ply -C uffizi_cross.hdr

=== debian/changelog ===
glslviewer (1.6) UNRELEASED; urgency=medium

A lot of new things but the biggest one are

  * Support for OBJ materials

  * Support for GLTF files

  * Default PBR shader

  * OSC support

  * Windows compile rutines

 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Wed, 23 Oct 2019 02:45:12 -0800

glslviewer (1.5) UNRELEASED; urgency=medium

  * Adding `frag`/`vert` console commands to print fragment/vertex source code

  * Adding -v/--verbose arguments

  * Adding --help argument

  * Changing -m argument for -c/--cursor

  * Compilation time now only shows on -v/--verbose mode

  * COUTs print w '//' at the beginning in case someone wants to use the output directly as source code


 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Sun, 26 Nov 2017 02:45:12 -0800

glslviewer (1.3) UNRELEASED; urgency=medium

  * Adding console gcc-like precompiler arguments to satisfy GLSL shaders dependencies -I[dir] -D[define]

  * Adding 'screenshot' command on CIN to save screenshots to other files rather than the specified on -o [file]

  * Adding travis and editorconfig files to help others contribute

  * General housekeeping of utils functions. Now they are split in tools/fs tools/text and tools/geom 
  * 

 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Wed, 16 Aug 2017 03:20:21 -0800

glslviewer (1.2) UNRELEASED; urgency=medium

  * Better Makefile: Using Broadcom SDK when is possible not... only on Raspberry Pi

  * Upgrading GLM to 0.9.8.4

  * Upgrading stb_image to 2.14

  * Upgrading stb_image_write to 1.03

  * Fixing and improving pixelDensity changes

  * Compatibility with ShaderToy Image Shaders (@doug-moen)

  * Verbose comments on compiling time and improvements on warnings and errors (@doug-moen)

  * Headless support

  * fixing recursive #include system

  * console outs for time, delta and fps on demand

 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Tue, 21 Feb 2017 14:20:28 -0500

glslviewer (1.1) unstable; urgency=low

  * Initial Release.

 -- Patricio Gonzalez Vivo <patriciogonzalezvivo@gmail.com>  Thu, 29 Sep 2016 06:43:54 -0400

=== PKGBUILD ===
# Maintainer: Naveen M K <naveen521kk@gmail.com> @naveen521kk on Github.

_realname=glslviewer
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.6.1
pkgrel=2
pkgdesc=" Console-based GLSL Sandbox for 2D/3D shaders shaders (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/patriciogonzalezvivo/glslViewer"
license=('spdx:BSD-3-Clause')
depends=(
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-glfw"
  "${MINGW_PACKAGE_PREFIX}-glew"
)
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
source=(
  "https://github.com/patriciogonzalezvivo/glslViewer/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
  '0001-add-mingw.patch'
  '0002-use-platform-windows-def.patch'
  '0003-add-missing-header.patch'
)
sha256sums=('2408e1662f2d4dd1922f00a747090c13ee8aff561123bdc86aff9da77b3ccf74'
            '608663342fa2efc54bb406e598b6fb1f090c07c137a5d121cf13fa276f72ae64'
            'a05d51af5be141e2217b5ae8c2b621d474bb1862d229fb4bc1d3f9ec94ae62aa'
            '806751b9cf1d0d4acccce0690dc2582f99f66d2d643bb56ddb98a1276b714bc6')

prepare () {
  cd "${srcdir}"/${_realname}-${pkgver}
  patch -Np1 -i "${srcdir}"/0001-add-mingw.patch
  patch -Np1 -i "${srcdir}"/0002-use-platform-windows-def.patch
  patch -Np1 -i "${srcdir}"/0003-add-missing-header.patch
  rm -r include/glew-2.1.0/*
}

build() {
  cd "${srcdir}"/${_realname}-${pkgver}
  make CXX=${CXX}
}

package() {
  install -Dm0755 "${srcdir}/${_realname}-${pkgver}/bin/glslViewer.exe" "${pkgdir}${MINGW_PREFIX}/bin/glslViewer.exe"
  install -Dm0755 "${srcdir}/${_realname}-${pkgver}/bin/glslLoader" "${pkgdir}${MINGW_PREFIX}/bin/glslLoader"
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md"
}

=== debian/control ===
Source: glslviewer
Section: unknown
Priority: optional
Maintainer: Patricio Gonzalez Vivo <patriciogonzalezvivo@gmail.com>
Build-Depends: debhelper (>=9), pkg-config, libglfw3-dev, libglu1-mesa-dev, libxrandr-dev,
 libxi-dev, libxcursor-dev, libxinerama-dev
Standards-Version: 3.9.6
Homepage: https://github.com/patriciogonzalezvivo/glslViewer

Package: glslviewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GlslViewer is a flexible console-base OpenGL Sandbox to display 2D/3D GLSL shaders without the need of an UI

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autotools-dev

override_dh_auto_install:
	install -D -m 0755 bin/glslViewer $$(pwd)/debian/glslviewer/usr/bin/glslViewer
	install -D -m 0755 bin/glslLoader $$(pwd)/debian/glslviewer/usr/bin/glslLoader
	install -D -m 0755 glslViewer.png $$(pwd)/debian/glslviewer/usr/share/pixmaps/glslViewer.png
	install -D -m 0755 glslViewer.desktop $$(pwd)/debian/glslviewer/usr/share/applications/glslViewer.desktop
